Option Explicit
Dim objFSO, objFuncFile, objLogFile, s
Dim currentPath, strFuncFile, strConfigFile

' Obtengo la ruta del script, y la de los ficheros de funciones y configuracion
set objFSO = CreateObject("Scripting.FileSystemObject")
currentPath = objFSO.GetParentFolderName(Wscript.ScriptFullName)
strFuncFile = currentPath & "\Funciones.vbs"
strConfigFile = currentPath & "\Config.ini"

' Incluyo el fichero de funciones
Set objFuncFile = objFSO.OpenTextFile(strFuncFile)
s = objFuncFile.ReadAll
objFuncFile.Close
ExecuteGlobal s

' Abro el fichero de log en modo append y empiezo a escribir
Set objLogFile = objFSO.OpenTextFile (ReadIni (strConfigFile, "variables", "logFile"), 8, True)
objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. Inicio de la ejecucion del fichero.")

' -----------------
' Cuerpo del script
' -----------------
' Parametros de conexion con el AD
Dim objADComputer : set objADComputer = Nothing
Dim strADFQDN, strADUserUsername, strADUserPassword
Dim strADComputerOU : strADComputerOU = NULL
Dim objOpenDS : set objOpenDS = Nothing
Dim strComputernameDefault : strComputernameDefault = CreateObject("WScript.Network").ComputerName
Dim strComputernameNew : strComputernameNew = NULL
Dim strSerialNumber : strSerialNumber = NULL
Dim objWmiQuery, objWmiQueryItem, joinADResultCode, joinADResultMsg
Dim objWShell : set objWShell = WScript.CreateObject("WScript.Shell")

' Recupero los valores del AD del fichero de configuracion
strADFQDN = Trim(ReadIni (strConfigFile, "variables", "adFQDN"))
strADUserUsername = Trim(ReadIni (strConfigFile, "variables", "adUserUsername"))
strADUserPassword = Trim(ReadIni (strConfigFile, "variables", "adUserPassword"))

' Le pongo el prefijo del dominio al usuario, si no se ha introducido
If InStr(strADUserUsername, "\") = 0 Then
	strADUserUsername = strADFQDN & "\" & strADUserUsername
End If	

' Hago una pausa para que inicie la red (en milisegundos)
Wscript.Sleep 10000

' Compruebo si puedo conectar al AD
On Error Resume Next
Set objOpenDS = GetObject("LDAP:").OpenDSObject("LDAP://" & strADFQDN, strADUserUsername, strADUserPassword, 1)
If Err.Number <> 0 Then

	' Escribo y cierro el fichero de log
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " ERROR. No se ha podido conectar al dominio: " & strADFQDN & ", desde equipo: " & strComputernameDefault & ", con credenciales: " & strADUserUsername)
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " ERROR. El equipo no se unira al AD.")
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. Fin de la ejecucion del fichero.")
	objLogFile.Close		

	' Salgo del script
	Wscript.Quit
End If	


' **********************
' Conectado correctamente a AD
' **********************

' Escribo el fichero de log
objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " OK. Conectado correctamente al dominio: " & strADFQDN & ", desde equipo: " & strComputernameDefault & ", con credenciales: " & strADUserUsername)

' Obtengo el numero de serie del equipo
strSerialNumber = GetSerialNumber

' Si obtengo el numero de serie
If isNull (strSerialNumber) Then

	' Escribo y cierro el fichero de log
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. No se ha podido leer el numero de serie de este equipo.")
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. Fin de la ejecucion del fichero.")
	objLogFile.Close			
				
	' Salgo del script
	Wscript.Quit	
Else

	' Consulto al directorio el numero de serie para obtener los datos del equipo
	set objADComputer = BuscarEquipoEnAD (strADFQDN, strADUserUsername, strADUserPassword, "serialNumber", strSerialNumber)
	
	' Si encuentro el equipo en el AD
	If objADComputer Is Nothing Then
	
		' Escribo y cierro el fichero de log
		objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. El numero de serie " & strSerialNumber & " no se ha encontrado en el AD.")
		objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. Fin de la ejecucion del fichero.")
		objLogFile.Close			
					
		' Salgo del script
		Wscript.Quit		
	Else
		strADComputerOU = objADComputer.ou
		strComputernameNew = objADComputer.cn
		objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " OK. El numero de serie " & strSerialNumber & " se ha encontrado en el AD, asociado al ordenador: " & strComputernameNew & ", en la OU: " & strADComputerOU)
	End If	
End If


' **********************
' Tengo los datos necesarios
' para renombrar y unir al AD
' **********************

' Cambio el nombre al equipo
If (RenombrarEquipo (strComputernameNew) = True) Then
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " OK. Renombrado de equipo correcto. De: " & strComputernameDefault & " a " & strComputernameNew & ".")
	
	' Uno el equipo al dominio
	Set objWmiQuery = GetObject("winmgmts:{impersonationLevel=Impersonate}!\\.\root\cimv2")
	For Each objWmiQueryItem in objWmiQuery.InstancesOf("Win32_ComputerSystem")

		' Unimos el equipo al AD
		joinADResultCode = objWmiQueryItem.JoinDomainOrWorkGroup(strADFQDN, strADUserPassword, strADUserUsername, strADComputerOU, 1+2+32+1024) 'NETSETUP_JOIN_DOMAIN + NETSETUP_ACCT_CREATE + NETSETUP_DOMAIN_JOIN_IF_JOINED + NETSETUP_JOIN_WITH_NEW_NAME
		
			'Set ArgObj = WScript.Arguments 'agrego la funcion de argumento
				strMachineObjectOU = ArgObj(0) 'establezco que el argumento 0 es el path de la OU que esta puesto como secuencia de tareas entre comillado
				
					If UCase(strMachineObjectOU) <> UCase(strADComputerOU) Then ' si la ou de destino es diferente que la del argumento, muevelo
						Set objNewOU = GetObject("LDAP://" & strMachineObjectOU)
						Set objMoveComputer = objNewOU.MoveHere("LDAP://" & strComputernameNew, strADComputerOU )
							
					objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " OK. Equipo movido " & strComputernameNew & " a la unidad: " & strMachineObjectOU & ".")
					
					End If
			
		' Compruebo el resultado de la union
		If joinADResultCode = 0 Then
			objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " OK. Equipo unido correctamente al dominio: " & strADFQDN & ". OU: " & strADComputerOU)
		Else
			joinADResultMsg = GetADJoinMensaje(joinADResultCode)
			objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " ERROR. El equipo no se ha podido unir al dominio: " & strADFQDN & ". Codigo: " & joinADResultCode & " - Mensaje: " & joinADResultMsg)
			objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " ERROR. Para mas detalle, consultar el fichero: C:\Windows\debug\NetSetup.log")
		End If
		
		Exit For
	Next	
Else
	objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " ERROR. No se ha podido cambiar el nombre al equipo. De: " & strComputernameDefault & " a " & strComputernameNew & ".")
End If	
' -----------------
' Fin Cuerpo del script
' -----------------

' Cierro el fichero de log y termino de escribir
objLogFile.WriteLine(Now() & " " & Wscript.ScriptFullName & " INFO. Fin de la ejecucion del fichero.")
objLogFile.Close
